# Visualization Library A lightweight C++ OpenGL middleware for 2D/3D graphics | [Home] [Tutorials] [All Classes] [Grouped Classes]

# vl::BlitFramebuffer Class Reference

A RenderingCallback that can be used to copy pixels from a framebuffer to another as described in GL_EXT_framebuffer_blit. More...

`#include <BlitFramebuffer.hpp>`

Inheritance diagram for vl::BlitFramebuffer:

List of all members.

## Public Member Functions
| BlitFramebuffer ()
virtual const char * | className ()
| Returns the name of the class.
void | copyPixels ()
| Performs the actual pixel copy from the read framebuffer to the draw framebuffer.
virtual bool | renderingCallback (const RenderingAbstract *, ERenderingCallback reason)
| Implements the actual code to be executed upon callback activation.
void | setReadFramebuffer (FBORenderTarget *fbo)
FBORenderTarget * | readFramebuffer () const
void | setDrawFramebuffer (FBORenderTarget *fbo)
FBORenderTarget * | drawFramebuffer () const
void | setSrcRect (int x0, int y0, int x1, int y1)
void | setDstRect (int x0, int y0, int x1, int y1)
const int * | srcRect () const
const int * | dstRect () const
void | setBufferMask (int buffer_mask)
| takes a bitmask combination of EBufferBits
int | bufferMask () const
void | setLinearFilteringEnabled (bool enable_linear_filtering)
bool | linearFilteringEnabled () const
## Protected Attributes
ref< FBORenderTarget > | mReadFramebuffer
ref< FBORenderTarget > | mDrawFramebuffer
int | mSrcRect [4]
int | mDstRect [4]
int | mBufferMask
bool | mLinearFilteringEnabled

## Detailed Description

A RenderingCallback that can be used to copy pixels from a framebuffer to another as described in GL_EXT_framebuffer_blit.

## Constructor & Destructor Documentation

vl::BlitFramebuffer::BlitFramebuffer | ( |  | ) | `[inline]`

## Member Function Documentation

virtual const char* vl::BlitFramebuffer::className | ( |  | ) | `[inline, virtual]`

Returns the name of the class.

Reimplemented from vl::RenderingCallback.

void vl::BlitFramebuffer::copyPixels | ( |  | ) | `[inline]`

Performs the actual pixel copy from the read framebuffer to the draw framebuffer.

virtual bool vl::BlitFramebuffer::renderingCallback | ( | const RenderingAbstract * | rendering,
|  | ERenderingCallback | reason |
| ) |  |  | `[inline, virtual]`

Implements the actual code to be executed upon callback activation.

Returns:
  `true` if the callback reacted to the given reason

Implements vl::RenderingCallback.

void vl::BlitFramebuffer::setReadFramebuffer | ( | FBORenderTarget * | fbo | ) | `[inline]`

FBORenderTarget* vl::BlitFramebuffer::readFramebuffer | ( |  | ) | const`[inline]`

void vl::BlitFramebuffer::setDrawFramebuffer | ( | FBORenderTarget * | fbo | ) | `[inline]`

FBORenderTarget* vl::BlitFramebuffer::drawFramebuffer | ( |  | ) | const`[inline]`

void vl::BlitFramebuffer::setSrcRect | ( | int | x0,
|  | int | y0,
|  | int | x1,
|  | int | y1 |
| ) |  |  | `[inline]`

void vl::BlitFramebuffer::setDstRect | ( | int | x0,
|  | int | y0,
|  | int | x1,
|  | int | y1 |
| ) |  |  | `[inline]`

const int* vl::BlitFramebuffer::srcRect | ( |  | ) | const`[inline]`

const int* vl::BlitFramebuffer::dstRect | ( |  | ) | const`[inline]`

void vl::BlitFramebuffer::setBufferMask | ( | int | buffer_mask | ) | `[inline]`

takes a bitmask combination of EBufferBits

int vl::BlitFramebuffer::bufferMask | ( |  | ) | const`[inline]`

void vl::BlitFramebuffer::setLinearFilteringEnabled | ( | bool | enable_linear_filtering | ) | `[inline]`

bool vl::BlitFramebuffer::linearFilteringEnabled | ( |  | ) | const`[inline]`

## Member Data Documentation

ref<FBORenderTarget> vl::BlitFramebuffer::mReadFramebuffer`[protected]`

ref<FBORenderTarget> vl::BlitFramebuffer::mDrawFramebuffer`[protected]`

int vl::BlitFramebuffer::mSrcRect[4]`[protected]`

int vl::BlitFramebuffer::mDstRect[4]`[protected]`

int vl::BlitFramebuffer::mBufferMask`[protected]`

bool vl::BlitFramebuffer::mLinearFilteringEnabled`[protected]`

The documentation for this class was generated from the following file:

- E:/VisualizationLibrary/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vl/BlitFramebuffer.hpp

Visualization Library v2009.08 Reference Documentation
Copyright 2005-2009 Michele Bosi. All rights reserved.
Updated on Sun Nov 8 14:28:56 2009.
Permission is granted to use this page to write and publish articles regarding Visualization Library.